
#include "SSD1306_minimal.h"
#include <avr/pgmspace.h>
SSD1306_Mini oled;

#define LED4 10
#define LED3 9
#define LED2 8
#define BUZZER 7 //switched w led1
#define LED1 5 //switched w buzzer

//#define BUZZER 5
//#define LED1 7 //switched w buzzer

#define BUTA 0
#define BUTB 1
#define JOYX 2
#define JOYY 3

enum player {
  PLAYERA,
  PLAYERB,
};

byte names[] = {'c', 'd', 'e', 'f', 'g', 'a', 'b', 'C'};  
int tones[] = {1915, 1700, 1519, 1432, 1275, 1136, 1014, 956};
byte melody[] = "2d2a1f2c2d2a2d2c2f2d2a2c2d2a1f2c2d2a2a2g2p8p8p8p";

int count = 0;
int count2 = 0;
int count3 = 0;
int MAX_COUNT = 24;

const int rows = 8;
const int columns = 8;
int prev_butA = LOW;
int prev_butB = LOW;
int current_player = PLAYERA; //BtnA = 0, BtnB = 1
int curs_row = 0; //cursor is at 0 by default. Going by game coordinates, not OLED
int curs_col = 0;
int prev_read_x;
int prev_read_y;
bool played_song = false;

char * menu_options[4] = {" Restart", " >Press B"}; 

char tic_tac_board[ rows ][ columns ] = 
{ 
  { ' ', ' ', '|', ' ', ' ', '|', ' ', ' '}, 
  { ' ', ' ', '|', ' ', ' ', '|', ' ', ' '}, 
  { '-', '-', '+', '-', '-', '+', '-', '-'}, 
  { ' ', ' ', '|', ' ', ' ', '|', ' ', ' '}, 
  { ' ', ' ', '|', ' ', ' ', '|', ' ', ' '}, 
  { '-', '-', '+', '-', '-', '+', '-', '-'}, 
  { ' ', ' ', '|', ' ', ' ', '|', ' ', ' '}, 
  { ' ', ' ', '|', ' ', ' ', '|', ' ', ' '},
};


char y[ 2 ][ 2 ] = 
{ 
  {'/','\\'},
  {'\\','/'}
};

char x[ 2 ][ 2 ] = 
{ 
  {'\\','/'},
  {'/','\\'}
};

char game[3][3] = {
  { ' ', ' ', ' '}, 
  { ' ', ' ', ' '}, 
  { ' ', ' ', ' '}
};

void play_song(){
  for (count = 0; count < MAX_COUNT; count++) {
      for (count3 = 0; count3 <= (melody[count*2] - 48) * 30; count3++) {
      for (count2=0;count2<8;count2++) {
        if (names[count2] == melody[count*2 + 1]) {       
          analogWrite(BUZZER,255);
          delayMicroseconds(tones[count2]);
          analogWrite(BUZZER, 0);
          delayMicroseconds(tones[count2]);
        } 
        if (melody[count*2 + 1] == 'p') {
          // make a pause of a certain size
          analogWrite(BUZZER, 0);
          delayMicroseconds(100);
        }
      }
    }
  }
}
void clear_board(){
  //border is at index 2 and 5
  for(int i = 0; i < rows; i++){
    for(int j = 0; j < columns; j++){
      if(i!= 2 && j!=2 && i!=5 && j!=5){
        tic_tac_board[i][j] = ' ';
      }
    }
  }

  for(int i = 0; i <3; i++){
    for(int j = 0; j < 3; j++){
      game[i][j] = ' ';
    }
  }
  menu_options[2] = ""; //Clear the winners string
  curs_row = 0;
  curs_col = 0;
  tic_tac_board[curs_row*3][curs_col*3] = '*';
  oled.clear();
}

//input in terms of player
void update_board_move(int r, int c, int current_player){
  char (*arr)[2][2];
  if(current_player == PLAYERA){
    arr = &x;
    game[curs_row][curs_col] = 'X';
  }
  else{
    arr = &y;
    game[curs_row][curs_col] = 'O';
  }
  int oled_r = r*3;
  int oled_c = c*3;

  int piece_r = 0;
  int piece_c = 0;

  //Draw piece based on player
  for(int row = oled_r; row < oled_r + 2; row++){
      piece_c = 0;
      for(int col = oled_c; col < oled_c + 2; col++){
          tic_tac_board[row][col] = (*arr)[piece_r][piece_c];
          piece_c++;
      }
      piece_r++;
  }

  
}

//returns true if it set it properly
bool set_cursor_earliest_open_spot(){
  for(int i = 0; i < 3; i++){
    for(int j = 0; j < 3; j++){
      //If free spot, then place cursor here
      if(game[i][j] == ' '){
        curs_row = i;
        curs_col = j;
        return true;
      }
    }
  }
  return false;
}

bool set_next_open_spot_curr(char dir){
  //if left, need to iterate col-1 from curr to 0
   if(dir == 'L'){
     int j = curs_col;
     for(int i = curs_row; i >=0; i--){
      for(;j >=0; j--){
        //If free spot, then place cursor here
        if(game[i][j] == ' ' && (i!=curs_row || j!=curs_col)){
          curs_row = i;
          curs_col = j;
          return true;
        }
        
      }
      j = 2;
     }
     
    //End to curr
    for(int i = 2; i >=curs_row; i--){
      for(int j = 2; j >=0; j--){
        if(game[i][j] == ' '){
          curs_row = i;
          curs_col = j;
          return true;
        }
      }
    }
    
   }
   
  else if(dir == 'R'){
    
    //Curr+1 to end
    int j = curs_col;
    for(int i = curs_row; i < 3; i++){
      for(; j < 3; j++){
        //If free spot, then place cursor here
         if(game[i][j] == ' ' && (i!=curs_row || j!=curs_col)){
          curs_row = i;
          curs_col = j;
          return true;
        }
      }
      j = 0;
    }
  
    //Start to curr
    for(int i = 0; i <=curs_row; i++){
      for(int j = 0; j < 2; j++){
        if(game[i][j] == ' '){
          curs_row = i;
          curs_col = j;
          return true;
        }
      }
    }
  }
  return false;
  
}

//true if there is, false if there isn't
bool ret_if_winner(){
  //Iterate each row at a time
  for(int i = 0; i < 3; i++){
    if(game[i][0]!= ' ' && game[i][0] == game[i][1] && (game[i][1] == game[i][2])){
      return true;
    }
  }
  //Iterate each column at a time
  for(int j = 0; j < 3; j++){
    if(game[0][j]!= ' ' && game[0][j] == game[1][j] && (game[1][j] == game[2][j])){
      return true;
    }
  }
  //Check diagonals
  if(game[0][0]!= ' ' && game[0][0] == game[1][1] && (game[1][1] == game[2][2])){
    return true;
  }
  else if(game[1][1]!= ' ' && game[2][0] == game[1][1] && (game[1][1] == game[0][2])){
    return true;
  }
  else{
    return false;
  }
}

void buzzHigh(int buzzer){
  analogWrite(buzzer, 200);
  delay(100);
  analogWrite(buzzer, 0);
}

void buzzLow(int buzzer){
  analogWrite(buzzer, 10);
  delay(100);
  analogWrite(buzzer, 0);
}
void blink_LED(int num, int del, bool led1, bool led2, bool led3, bool led4){
  for(int i = 0; i < num; i++){
      buzzHigh(BUZZER);
      if(led1)
        digitalWrite(LED1, HIGH);
      if(led2)
        digitalWrite(LED2, HIGH);
      if(led3)
        digitalWrite(LED3, HIGH);
      if(led4)
        digitalWrite(LED4, HIGH);
      delay(del);
      buzzLow(BUZZER);
      if(led1)
        digitalWrite(LED1, LOW);
      if(led2)
        digitalWrite(LED2, LOW);
      if(led3)
        digitalWrite(LED3, LOW);
      if(led4)
        digitalWrite(LED4, LOW);
      delay(del);
  }
}



void displayStart(){
  oled.cursorTo(8,2);
  oled.printString("IEEE Workshops");
  oled.cursorTo(20,4);
  oled.printString("TIC TAC TOE");
  blink_LED(3, 500,true, true, true, true);
}

void displayGame(){
    //Left side
  for(int r = 0; r < rows; r++){
    oled.cursorTo(0,r);
    for(int c = 0; c < columns; c++){
      oled.printChar(tic_tac_board[r][c]);
    }
  }

  //Right side
  int menu_row = 2;

  for(int i = menu_row; i<=5; i++){
    oled.cursorTo(128/2,i);
    oled.printString(menu_options[i-2]);    
  }
  
}
void setup() {
  // put your setup code here, to run once:
  pinMode(LED1, OUTPUT);
  pinMode(LED2, OUTPUT);
  pinMode(LED3, OUTPUT);
  pinMode(LED4, OUTPUT);
  pinMode(BUTA, INPUT);
  pinMode(BUTB, INPUT); 
  pinMode(JOYX, INPUT);
  pinMode(JOYY, INPUT);
  pinMode(BUZZER, OUTPUT);
  
  oled.init(0x3c);
  oled.clear();
  
  displayStart();
  tic_tac_board[curs_row*3][curs_col*3] = '*';
  prev_read_x = analogRead(JOYX);
  prev_read_y = analogRead(JOYY);

  play_song();
  oled.clear();
}

//Add "UCLA IEEE Workshops presents" screen along with sound and LED
//Add Tic Tac Toe screen
//Add ability to select from menu
//Test with joystick
//Add sound and LED components. 2 LEDs on left should be for player 1 and 2 LEDs on right should be player 2


void loop() {
  // put your main code here, to run repeatedly:
  int curr_butA = digitalRead(BUTA);
  int curr_butB = digitalRead(BUTB);
  int current_reading_y = analogRead(JOYY); //left and right 
  int current_reading_x = analogRead(JOYX); //up (larger) and down (smaller va)

    //If we use the joystick to go right
    if(current_reading_y <= 100 && prev_read_y > 100){
      buzzLow(BUZZER);
      //If button B is pressed, we want to increment "cursor" to the next avaiable spot by looking at the game array
      if(ret_if_winner() == false){
        tic_tac_board[curs_row*3][curs_col*3] = ' ';
        if(set_next_open_spot_curr('R'))
          tic_tac_board[curs_row*3][curs_col*3] = '*';
      }
    }
    //Joystick to the left
    else if(current_reading_y >= 1000 && prev_read_y < 1000){
      buzzHigh(BUZZER);
      if(ret_if_winner() == false){
        tic_tac_board[curs_row*3][curs_col*3] = ' ';
        if(set_next_open_spot_curr('L'))
          tic_tac_board[curs_row*3][curs_col*3] = '*';
      }
    }

    //If B pressed, restart game
    if(curr_butB == LOW && prev_butB == HIGH){
      played_song = false;
      menu_options[2] = "";
      oled.clear();
      clear_board();
    }

    //If A pressed (button is let go), place mark depending on current player
    if(curr_butA == LOW && prev_butA == HIGH){
      tic_tac_board[curs_row*3][curs_col*3] = ' ';
      update_board_move(curs_row,curs_col,current_player);

      if(current_player == PLAYERA){
        blink_LED(1, 300, false, false, true, true);
      }
      else if(current_player == PLAYERB){
        blink_LED(1, 300, true, true, false, false);
      }
      //Check if game is over and display who won
      if(ret_if_winner() == true){
        menu_options[2] = " X wins!";
        if(current_player == PLAYERB)
          menu_options[2] = " O wins!";
      }
      //Otherwise, continue game
      else{
        if(set_cursor_earliest_open_spot())
          tic_tac_board[curs_row*3][curs_col*3] = '*';
        //If cannot find any open spots, then check if there is a win or tie. Either way, game is over.
        else{
          menu_options[2] = " Tie!";
        }
       
      }

      //Swtich current player
      if(current_player == PLAYERA)
        current_player = PLAYERB;
      else if(current_player == PLAYERB)
        current_player = PLAYERA;
   
    }
    
    prev_butB = curr_butB;
    prev_butA = curr_butA;
    prev_read_y = current_reading_y;
    prev_read_x = current_reading_x;

  displayGame();
  if(ret_if_winner() == true && played_song == false){
    played_song = true;
    blink_LED(3, 500, true, true, true, true);
    play_song();
  }
}
